# PBSWeb: A Web-based Interface to PBS
# Copyright (C) 2000, 2001  Paul Lu
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# .......................
# Please leave this copyright notice intact.
# See http://www.gnu.org/copyleft/gpl.html for further details
# 
# Contact information:
# 	Paul Lu
# 	Assistant Professor
# 	Dept. of Computing Science
# 	Athabasca Hall
# 	University of Alberta
# 	Edmonton, Alberta, T6G 2E8
# 	Canada
# 
# 	E-mail:         paullu@cs.ualberta.ca
# 	Web:            http://www.cs.ualberta.ca/~paullu/
# 
# Other contributors to PBSWeb (as of July 2001)
# 	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
# 	Jonathan Schaeffer, Duane Szafron
#
# Insanely simple python script to return the file modification time.
# Chris Pinchak, May 15, 2001

import sys, os
from stat import *

if len(sys.argv) == 2:
	if os.access(sys.argv[1], os.F_OK):
		result = os.stat(sys.argv[1])
		print result[ST_MTIME]
	else:
		print -1
else:
	print -1
