<?php
  session_start();

/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/
  session_register('username');
  session_register('sessionkey');

  include_once("dbutils.php");
  if(""!=$sessionkey)
  { DB_authPage($sessionkey); }
  else
  { $sessionkey=DB_login($username, $password); }
?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>PBSWeb Start Page</title>
    <script language="JavaScript">
    <!-- Hide script
        // window.location.reload();
	// window.location.href=window.location.href;
    // End script hiding -->
    </script>
  </head>
  <body bgcolor="white">
    <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">PBSWeb Start Page
    </h1>
    <hr>
    <table width="100%">
      <tr>
	<td>
	   <table border="5" cellpadding="6">
	   <tr>
	      <td height="400" width="450" valign="top">
		<font size="+2">
		  <img src="img/upload.gif" height="32" width="32" alt="File Upload">
		  <a href="upload.php">Tar File Upload</a><br><br>
		  <img src="img/compile.gif" height="32" width="32" alt="Compile Files">
		  <a href="programselectc.php">Compile Uploaded Files</a><br><br>
		  <img src="img/script.gif" height="32" width="32" alt="Script Generation and Job Submission">
		  <a href="programselects.php">Script Generation and Submission</a><br><br>
		  <img src="img/info.gif" height="32" width="32" alt="PBS Queue Info">
		  <a href="qstat.php">PBS Queue Information</a><br><br>
		  <img src="img/colors.gif" height="32" width="32" alt="File Operations">
		  <a href="programselecto.php">View Job Output</a><br>
<!-- Paul
		  <img src="img/logout.gif" height="32" width="32" alt="Logout">
-->
<p>
		  <a href="logout.php">Logout</a><br>
		  <a href="changepasswd.php">Change PBSWeb Password</a></br>
		  </font>
	      </td>
	    </tr>
	  </table>
	</td>
        <td>
          <table border="5" cellpadding="6" >
            <tr>
              <td height="390" width="254">
                <center>
                  <img src="img/macitext.gif" border="0" height="211" width="188" alt="MACI Image">
                  <br>
                  <img src="img/logo.gif" border="0" height="68" width="254" alt="U of A CS Logo">
                </center>
              </td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
    <hr>
    <p>Send questions and comments to <a
    href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a>. You can find <a
    href='help.html'> help here </a>.</p>
  </body>
</html>
