<?php
  session_start();
# echo "<!-- $sessionkey $username -->";

/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/

/*
// TODO:  Add extra advice if sessionkey is empty (i.e., file is too large)
  if( $sessionkey == "" )
  {
    echo "session key is blank";
  }
*/

  session_register('username');
  session_register('sessionkey');
  
  include ("dbutils.php");
  include("PBSWebConstants.php");
  DB_authPage($sessionkey);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>PBSWeb File Upload</title>
  </head>
  <body bgcolor="white">
    <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">PBSWeb File Upload
    </h1>

<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>

    <hr>
        <?php
        if (($userfile != "none") && $program) {
	  $program_exists=FALSE;
	  $label_error=FALSE;

	  $program=chop($program);
	  if (ereg(' ', $program)) {
	    $label_error=TRUE;
	  }
  
# echo "<!-- XXX $sessionkey $username $host $program --><br>";
# echo "<!-- ZZZ $PBSDatabaseConnectString ZZ $PBSDatabaseName ZZ $username --><br>";


	# Paul hacked this to pass in the database name too, even though
	# it should be part of the global namespace
	  # $program_exists=DB_ProgramExists($username,$host,$program);
	  $program_exists=DB_ProgramExists($username,$host,$program,$PBSDatabaseName);

# echo "<!-- AAA $PBSDatabaseConnectString ZZ $PBSDatabaseName ZZ $username --><br>";

	  if ($label_error || ($program_exists != PBSFALSERET)) {
	    if ($label_error) {
	      ?><p><font color="red">Input error: The program label you entered contains whitespace.</font></p><?php
		   }
	    if ($program_exists) {
              ?><p><font color="red">Input error: The program label you entered already exists.</font></p><?php
		   }
	      ?>
		<FORM ENCTYPE="multipart/form-data" ACTION="upload.php" METHOD=POST>
		<table><tr align="left"><th>Enter a File to Upload: </th><td>
		<INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="52428800">
		<INPUT NAME="userfile" TYPE="file"></td></tr>
		<TR ALIGN="LEFT"><TH>Upload Destination:</TH>
		<TD><SELECT NAME="host"><OPTION value="default">Default
		<?php 
		   $hostlist = DB_get_machines_list($username);
	           $hostcount = sizeof($hostlist);
		   for($i=0;$i<$hostcount;$i++) {
		     $curhost=$hostlist[$i];
		     echo "<OPTION VALUE=\x22$curhost\x22>$curhost";
		   }
	    ?>
	    </SELECT>       
	    </TD></TR>
	    <TR ALIGN="LEFT"><TH><font color="red">Enter a Label for this Program: </font></TH>
	    <TD><INPUT TYPE="text" NAME="program"> (continuous alpha-numeric string)</TD></TR>
	    <TR ALIGN="LEFT"><TH>Do Make? </TH>
	    <TD>
	    <INPUT TYPE="checkbox" NAME="domake" VALUE="Yes" CHECKED> 
	    <tr><td>
	    <INPUT TYPE="submit" VALUE="Submit"></td></tr></table></FORM><?php
									    }
	
	    else {
	      if (is_uploaded_file($userfile)) {
		copy($userfile, "$TEMPUPLOADDIR/$username/$userfile_name");
	      }
	      else {
		echo "Possible file upload attack: filename '$userfile'.";
	      }
	  
	      if ($host == "default") {
		$host = $DEFAULTHOST;
	      }
	      #echo "<p>$username</p>";
	      #echo "<p>$userfile</p>";
	      echo "<h2>Upload Results</h2>";
	      echo "<table border=\x220\x22>";
	      echo "<tr><th align=\x22LEFT\x22>Filename:</th><td>$userfile_name</td></tr>";
	      echo "<tr><th align=\x22LEFT\x22>Program label:</th><td>$program</td></th>";
	      echo "<tr><th align=\x22LEFT\x22>Host:</th><td>$host</td></tr></table>";
	 
	      $chmod = `chmod go-rwx "$TEMPUPLOADDIR/$username/$userfile_name"; chmod u-x "$TEMPUPLOADDIR/$username/$userfile_name"`;
	      $mkdir = `ssh -l "$username" "$host" 'mkdir $PBSWEBDIR/$program;exit' 2>&1`; 
	      echo "<p>$mkdir</p>";
	      $securecopy = `scp "$TEMPUPLOADDIR/$username/$userfile_name" "$username@$host:~/$PBSWEBDIR/$program" 2>&1`;
	      echo "<p>$securecopy</p>";
	      $remove_temp =  `rm -f "$TEMPUPLOADDIR/$username/$userfile_name"`;
	      if (ereg("gz$",$userfile_name)) {
                $untarlist = `ssh -l "$username" "$host" 'cd $PBSWEBDIR/$program; tar -ztf $userfile_name;exit' 2>&1`;
		$untar = `ssh -l "$username" "$host" 'cd $PBSWEBDIR/$program; tar -zxvf $userfile_name;exit' 2>&1`;
	      }
	      else {
                $untarlist = `ssh -l "$username" "$host" 'cd $PBSWEBDIR/$program; tar -tf $userfile_name;exit' 2>&1`;
		$untar = `ssh -l "$username" "$host" 'cd $PBSWEBDIR/$program; tar -xvf $userfile_name;exit' 2>&1`;
	      }
	      echo "<p><b>untar output:</b><br><pre>$untar</pre></p>";

	      $tarfiles = explode("\n",$untarlist);
              $program_path=$tarfiles[0];
	      if ((!(ereg("/$",$program_path)))||($program_path=="./")) {
		$program_path="";
	      } 
              echo "<p>$program_path</p>";

	      if ($domake == "Yes") {
		$make = `ssh -l "$username" "$host" 'cd $PBSWEBDIR/$program;make;exit' 2>&1`;
		echo "<p><b>make output:</b><br><pre>$make</pre></p>";
	      }		
	      
	      $uploaded=TRUE;

      	      # add the new program to the database
	      $pinsert =  DB_submit_program($username, $sessionkey, $program, $userfile_name,$program_path, $host);
	      if ($pinsert == PBSFALSERET) {
		echo "<p>Error Adding Program to Database</p>";
	      }
	    }
	}
        else { ?>
	<FORM ENCTYPE="multipart/form-data" ACTION="upload.php" METHOD=POST>
	<table><tr align="left"><th>Enter a File to Upload:
		<br><font color=red>Warning:  Must be less than 50 MB!</font>
				</th>
	<td>
	<INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="52428800">
	<INPUT NAME="userfile" TYPE="file"></td></tr>
	<TR ALIGN="LEFT"><TH>Upload Destination:</TH>
	<TD><SELECT NAME="host"><OPTION value="default">Default
	<?php 
           #get the list of hosts from the database
	   $hostlist = DB_get_machines_list($username);
	   $hostcount = sizeof($hostlist);
	   for($i=0;$i<$hostcount;$i++) {
	     $curhost=$hostlist[$i];
	     echo "<OPTION VALUE=\x22$curhost\x22>$curhost";
	   }
	?>
	</SELECT>       
	</TD></TR>
	<TR ALIGN="LEFT"><TH>Enter a Label for this Program: </TH>
	<TD><INPUT TYPE="text" NAME="program">
		<font color=red>(contiguous alpha-numeric string)</font></TD></TR>
	<TR ALIGN="LEFT"><TH>Do Make? </TH>
	<TD>
	<INPUT TYPE="checkbox" NAME="domake" VALUE="Yes" CHECKED> 
	<tr><td><INPUT TYPE="hidden" NAME="username" VALUE=" $username"> 
	<INPUT TYPE="submit" VALUE="Submit"></td></tr></table></FORM>	  
	<?php } ?>

    <hr>
    <table border="0">
    <tr>
    <td>
     <?php
    if ($uploaded) {
    echo "<a href=submitscript.php?program=$program&host=$host&orders=newjob>Continue to Script Generation</a> | ";
      #echo "<FORM ACTION=submitscript.php METHOD=GET><input type=hidden name=program value=$program><input type=hidden name=host value=$host><input type=submit value=\x22Continue\x22></form>"; 
    }
    ?>
    Suggested Next Step:  <a href="mainmenu.php">Start Page</a></td>
    </tr>
    <tr>
    <td>Send questions and comments to <a
    href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a>. You can find <a
    href='help.html'> help here </a>. </td>
    </tr>  
    </table>
  </body>
</html>
