<?php
  session_start();

/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/

  session_register('username');
  session_register('sessionkey');
  
  include_once("dbutils.php");
  include_once("PBSWebConstants.php");
  DB_authPage($sessionkey);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>PBSWeb Program Compilation</title>
  </head>
  <body bgcolor="white">
    <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">PBSWeb Program Compilation
    </h1>

<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>
    <hr>

        <?php
        if ($host && $program) {
	  # Keeping this code around for potential future use.
	  #$program_path=DB_getProgramPath($username,$host,$program);
    	  if ($clean == "yes") {
	    # Keeping this code around for potential future use.
	    #$makeclean = `ssh -l $username $host 'cd $PBSWEBDIR/$program/$program_path;make clean; exit' 2>&1`;
	    $makeclean = `ssh -l $username $host 'cd $PBSWEBDIR/$program;make clean; exit' 2>&1`;
	    echo "<h2>make clean output:</h2>";
	    echo "<pre>$makeclean</pre>";
	  }

	  # Keeping this code around for potential future use.
	  #$make = `ssh -l $username $host 'cd $PBSWEBDIR/$program/$program_path;make ; exit' 2>&1`;
	  $make = `ssh -l $username $host 'cd $PBSWEBDIR/$program;make ; exit' 2>&1`;
	  echo "<h2>make output:</h2>";
	  echo "<pre>$make</pre>";
	
	  $compiled = TRUE;
	}
        else {
	  echo "<p>Not enough information to process request</p>";
        } ?>
    <hr>
    <table border="0">
    <tr>
 
    <td>
<?php
    if ($compiled) {
      echo "Suggested Next Step: <a href=submitscript.php?program=$program&host=$host>Continue to Script Generation</a> | ";
    }
    ?>
    <a href="mainmenu.php">Start Page</a></td>
    </tr>
    <tr>
    <td colspan="2">Send questions and comments to <a href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a></td>
    </tr>  
    </table>
  </body>
</html>


































































































































































































































